package;


import haxe.io.Bytes;
import lime.utils.AssetBundle;
import lime.utils.AssetLibrary;
import lime.utils.AssetManifest;
import lime.utils.Assets;

#if sys
import sys.FileSystem;
#end

@:access(lime.utils.Assets)


@:keep @:dox(hide) class ManifestResources {


	public static var preloadLibraries:Array<AssetLibrary>;
	public static var preloadLibraryNames:Array<String>;
	public static var rootPath:String;


	public static function init (config:Dynamic):Void {

		preloadLibraries = new Array ();
		preloadLibraryNames = new Array ();

		rootPath = null;

		if (config != null && Reflect.hasField (config, "rootPath")) {

			rootPath = Reflect.field (config, "rootPath");

		}

		if (rootPath == null) {

			#if (ios || tvos || emscripten)
			rootPath = "assets/";
			#elseif android
			rootPath = "";
			#elseif console
			rootPath = lime.system.System.applicationDirectory;
			#else
			rootPath = "./";
			#end

		}

		Assets.defaultRootPath = rootPath;

		#if (openfl && !flash && !display)
		
		#end

		var data, manifest, library, bundle;

		#if kha

		null
		library = AssetLibrary.fromManifest (manifest);
		Assets.registerLibrary ("null", library);

		if (library != null) preloadLibraries.push (library);
		else preloadLibraryNames.push ("null");

		#else

		data = '{"name":null,"assets":"aoy4:sizei2967y4:typey5:IMAGEy9:classNamey27:__ASSET__img_characters_pngy2:idy20:img%2Fcharacters.pnggoR0i62271R1y4:TEXTR3y23:__ASSET__img_openfl_svgR5y16:img%2Fopenfl.svggoR0i210R1R7R3y30:__ASSET__bulletml_template_xmlR5y23:bulletml%2Ftemplate.xmlgoR0i709R1R7R3y41:__ASSET__bulletml__1943__rolling_fire_xmlR5y38:bulletml%2F%5B1943%5D_rolling_fire.xmlgoR0i788R1R7R3y56:__ASSET__bulletml__guwange__round_2_boss_circle_fire_xmlR5y53:bulletml%2F%5BGuwange%5D_round_2_boss_circle_fire.xmlgoR0i1685R1R7R3y54:__ASSET__bulletml__guwange__round_3_boss_fast_3way_xmlR5y51:bulletml%2F%5BGuwange%5D_round_3_boss_fast_3way.xmlgoR0i1147R1R7R3y53:__ASSET__bulletml__guwange__round_4_boss_eye_ball_xmlR5y50:bulletml%2F%5BGuwange%5D_round_4_boss_eye_ball.xmlgoR0i1045R1R7R3y45:__ASSET__bulletml__g_darius__homing_laser_xmlR5y42:bulletml%2F%5BG_DARIUS%5D_homing_laser.xmlgoR0i772R1R7R3y57:__ASSET__bulletml__progear__round_1_boss_grow_bullets_xmlR5y54:bulletml%2F%5BProgear%5D_round_1_boss_grow_bullets.xmlgoR0i927R1R7R3y55:__ASSET__bulletml__progear__round_2_boss_struggling_xmlR5y52:bulletml%2F%5BProgear%5D_round_2_boss_struggling.xmlgoR0i956R1R7R3y55:__ASSET__bulletml__progear__round_3_boss_back_burst_xmlR5y52:bulletml%2F%5BProgear%5D_round_3_boss_back_burst.xmlgoR0i1002R1R7R3y57:__ASSET__bulletml__progear__round_3_boss_wave_bullets_xmlR5y54:bulletml%2F%5BProgear%5D_round_3_boss_wave_bullets.xmlgoR0i1473R1R7R3y56:__ASSET__bulletml__progear__round_4_boss_fast_rocket_xmlR5y53:bulletml%2F%5BProgear%5D_round_4_boss_fast_rocket.xmlgoR0i625R1R7R3y60:__ASSET__bulletml__progear__round_5_boss_last_round_wave_xmlR5y57:bulletml%2F%5BProgear%5D_round_5_boss_last_round_wave.xmlgoR0i825R1R7R3y59:__ASSET__bulletml__progear__round_5_middle_boss_rockets_xmlR5y56:bulletml%2F%5BProgear%5D_round_5_middle_boss_rockets.xmlgoR0i1085R1R7R3y58:__ASSET__bulletml__progear__round_6_boss_parabola_shot_xmlR5y55:bulletml%2F%5BProgear%5D_round_6_boss_parabola_shot.xmlgoR0i439R1R7R3y50:__ASSET__bulletml__psyvariar__x_a_boss_opening_xmlR5y47:bulletml%2F%5BPsyvariar%5D_X-A_boss_opening.xmlgoR0i1432R1R7R3y49:__ASSET__bulletml__psyvariar__x_a_boss_winder_xmlR5y46:bulletml%2F%5BPsyvariar%5D_X-A_boss_winder.xmlgoR0i1208R1R7R3y60:__ASSET__bulletml__psyvariar__x_b_colony_shape_satellite_xmlR5y57:bulletml%2F%5BPsyvariar%5D_X-B_colony_shape_satellite.xmlgoR0i1163R1R7R3y43:__ASSET__bulletml__xevious__garu_zakato_xmlR5y40:bulletml%2F%5BXEVIOUS%5D_garu_zakato.xmlgh","rootPath":null,"version":2,"libraryArgs":[],"libraryType":null}';
		manifest = AssetManifest.parse (data, rootPath);
		library = AssetLibrary.fromManifest (manifest);
		Assets.registerLibrary ("default", library);
		

		library = Assets.getLibrary ("default");
		if (library != null) preloadLibraries.push (library);
		else preloadLibraryNames.push ("default");
		

		#end

	}


}


#if kha

null

#else

#if !display
#if flash

@:keep @:bind @:noCompletion #if display private #end class __ASSET__img_characters_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__img_openfl_svg extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml_template_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__1943__rolling_fire_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__guwange__round_2_boss_circle_fire_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__guwange__round_3_boss_fast_3way_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__guwange__round_4_boss_eye_ball_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__g_darius__homing_laser_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_1_boss_grow_bullets_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_2_boss_struggling_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_3_boss_back_burst_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_3_boss_wave_bullets_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_4_boss_fast_rocket_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_5_boss_last_round_wave_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_5_middle_boss_rockets_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_6_boss_parabola_shot_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__psyvariar__x_a_boss_opening_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__psyvariar__x_a_boss_winder_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__psyvariar__x_b_colony_shape_satellite_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__bulletml__xevious__garu_zakato_xml extends flash.utils.ByteArray { }
@:keep @:bind @:noCompletion #if display private #end class __ASSET__manifest_default_json extends flash.utils.ByteArray { }


#elseif (desktop || cpp)

@:keep @:image("assets/img/characters.png") @:noCompletion #if display private #end class __ASSET__img_characters_png extends lime.graphics.Image {}
@:keep @:file("assets/img/openfl.svg") @:noCompletion #if display private #end class __ASSET__img_openfl_svg extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/template.xml") @:noCompletion #if display private #end class __ASSET__bulletml_template_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[1943]_rolling_fire.xml") @:noCompletion #if display private #end class __ASSET__bulletml__1943__rolling_fire_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Guwange]_round_2_boss_circle_fire.xml") @:noCompletion #if display private #end class __ASSET__bulletml__guwange__round_2_boss_circle_fire_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Guwange]_round_3_boss_fast_3way.xml") @:noCompletion #if display private #end class __ASSET__bulletml__guwange__round_3_boss_fast_3way_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Guwange]_round_4_boss_eye_ball.xml") @:noCompletion #if display private #end class __ASSET__bulletml__guwange__round_4_boss_eye_ball_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[G_DARIUS]_homing_laser.xml") @:noCompletion #if display private #end class __ASSET__bulletml__g_darius__homing_laser_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Progear]_round_1_boss_grow_bullets.xml") @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_1_boss_grow_bullets_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Progear]_round_2_boss_struggling.xml") @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_2_boss_struggling_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Progear]_round_3_boss_back_burst.xml") @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_3_boss_back_burst_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Progear]_round_3_boss_wave_bullets.xml") @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_3_boss_wave_bullets_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Progear]_round_4_boss_fast_rocket.xml") @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_4_boss_fast_rocket_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Progear]_round_5_boss_last_round_wave.xml") @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_5_boss_last_round_wave_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Progear]_round_5_middle_boss_rockets.xml") @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_5_middle_boss_rockets_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Progear]_round_6_boss_parabola_shot.xml") @:noCompletion #if display private #end class __ASSET__bulletml__progear__round_6_boss_parabola_shot_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Psyvariar]_X-A_boss_opening.xml") @:noCompletion #if display private #end class __ASSET__bulletml__psyvariar__x_a_boss_opening_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Psyvariar]_X-A_boss_winder.xml") @:noCompletion #if display private #end class __ASSET__bulletml__psyvariar__x_a_boss_winder_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[Psyvariar]_X-B_colony_shape_satellite.xml") @:noCompletion #if display private #end class __ASSET__bulletml__psyvariar__x_b_colony_shape_satellite_xml extends haxe.io.Bytes {}
@:keep @:file("assets/bulletml/[XEVIOUS]_garu_zakato.xml") @:noCompletion #if display private #end class __ASSET__bulletml__xevious__garu_zakato_xml extends haxe.io.Bytes {}
@:keep @:file("") @:noCompletion #if display private #end class __ASSET__manifest_default_json extends haxe.io.Bytes {}



#else



#end

#if (openfl && !flash)

#if html5

#else

#end

#end
#end

#end
